﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Threading;

namespace Pongu
{

    public partial class MainWindow : Window
    {

        int speed = 11; 
        int ballspeedX = 5;
        int ballspeedY = 5;

        bool goUpL;
        bool goDownL;
        bool goUpR;
        bool goDownR;

        bool mr;
        bool ml;

        double ballx = 5;
        double bally = 5;

        int scoreL = 0;
        int scoreP = 0;


        public MainWindow()
        {
            InitializeComponent();

            DispatcherTimer dispatcherTimer = new DispatcherTimer();
            dispatcherTimer.Tick += Timer_Tick;
            dispatcherTimer.Interval = TimeSpan.FromMilliseconds(20);
            dispatcherTimer.Start();

        }

        private void PoleGry_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.Key == Key.S) goDownL = true;
            if (e.Key == Key.W) goUpL = true;
            if (e.Key == Key.Down) goDownR = true;
            if (e.Key == Key.Up) goUpR = true;

        }

        private void PoleGry_KeyUp(object sender, KeyEventArgs e)
        {
            if (e.Key == Key.S) goDownL = false;
            if (e.Key == Key.W) goUpL = false;
            if (e.Key == Key.Down) goDownR = false;
            if (e.Key == Key.Up) goUpR = false;
        }

        private void Timer_Tick(object sender, EventArgs e)
        {

            ballx = Canvas.GetLeft(Ball) + ballspeedX;
            Canvas.SetLeft(Ball, ballx);
            bally = Canvas.GetTop(Ball) + ballspeedY;
            Canvas.SetTop(Ball, bally);

            punktyP.Content = scoreP;
            punktyL.Content = scoreL;

            if (ballspeedX > 0) { mr = true; ml = false; }
            if (ballspeedX < 0) { mr = false; ml = true; }




            if (Canvas.GetLeft(Ball) + Ball.Width > Application.Current.MainWindow.Width)
            {
                ballspeedX = 5;
                Canvas.SetLeft(Ball, 400);
                ballspeedX = -ballspeedX;
                scoreL++;
            }


            if (Canvas.GetLeft(Ball) < 0 )
            {
                ballspeedX = -5;
                Canvas.SetLeft(Ball, 400);
                ballspeedX = -ballspeedX;
                scoreP++;
            }

            if (Canvas.GetTop(Ball) < 0 || Canvas.GetTop(Ball) + Ball.Height > Application.Current.MainWindow.Height - 40)
            {
                ballspeedY = -ballspeedY;
            }

            if ( Canvas.GetTop(Ball) + Ball.ActualHeight > Canvas.GetTop(leftPad) && Canvas.GetTop(Ball) - Ball.ActualHeight  < Canvas.GetTop(leftPad) + leftPad.Height  && Canvas.GetLeft(Ball) < Canvas.GetLeft(leftPad) + leftPad.Width && Canvas.GetLeft(Ball) > Canvas.GetLeft(leftPad) && ml) ballspeedX = -ballspeedX + 2;
            if ( Canvas.GetTop(Ball) + Ball.ActualHeight > Canvas.GetTop(rightPad) && Canvas.GetTop(Ball) - Ball.ActualHeight < Canvas.GetTop(rightPad) + rightPad.Height  && Canvas.GetLeft(Ball) > Canvas.GetLeft(rightPad) - rightPad.Width && Canvas.GetLeft(Ball) < Canvas.GetLeft(rightPad) && mr) ballspeedX = -ballspeedX - 2;

            if (goUpL == true && Canvas.GetTop(leftPad) > 0) Canvas.SetTop(leftPad, Canvas.GetTop(leftPad) - speed);
            if (goDownL == true && Canvas.GetTop(leftPad) < Application.Current.MainWindow.Height - 130) Canvas.SetTop(leftPad, Canvas.GetTop(leftPad) + speed);
            if (goUpR == true && Canvas.GetTop(rightPad) > 0) Canvas.SetTop(rightPad, Canvas.GetTop(rightPad) - speed);
            if (goDownR == true && Canvas.GetTop(rightPad) < Application.Current.MainWindow.Height - 130) Canvas.SetTop(rightPad, Canvas.GetTop(rightPad) + speed);

            if (scoreL == 3) { MessageBox.Show("Wygral gracz 1"); System.Windows.Application.Current.Shutdown(); }
            if (scoreP == 3) { MessageBox.Show("Wygral gracz 2"); System.Windows.Application.Current.Shutdown(); }

        }



    }
}
